import React, { Component } from 'react'
import PropTypes from 'prop-types'

const pattern = new RegExp('http(s)?://[^s]*')
class ImgLoad extends Component {
  state = {
    loaded: false,
  }
  onLoad = () => {
    this.setState({ loaded: true })
  }

  render() {
    let { src, imageProcess, ...props } = this.props
    if (!pattern.test(src)) {
      return 'The img src link prefix must be http or https'
    }
    src = this.state.loaded ? src : `${src}${imageProcess}`
    return <img src={src} onLoad={this.onLoad} {...props} />
  }
}

export default ImgLoad
ImgLoad.propTypes = { imageProcess: PropTypes.string }
ImgLoad.defaultProps = {
  imageProcess:
    '?imageMogr2/thumbnail/20x20/format/webp/blur/1x0/quality/75|imageslim',
}
